import re
from os import listdir, sep
import os

reg = re.compile(r"""
        (\d*?) # ID
        \..*?_\[
        (.*?) # miler index
        ]_\(
        (.*?) # width
        \)_?(?:\[
        (.*?) # width control
        ]|.*?).cif
    """, re.VERBOSE)

reg2 = re.compile(r"(-?\d)")


def get_data(fp):
    for f in listdir(fp):
        if ".cif" in f:
            res = reg.findall(f)
            if res and res[0][3]:
                res = res[0]
                mid = res[0]
                miler_index = [[int(j) for j in reg2.findall(i)] for i in res[1].split(',')]
                width = res[2]
                res3 = res[3].split(',')
                res3[2] = res3[2].strip("x")
                width_control = [int(i) for i in res3]
                yield mid, miler_index, width, width_control


def search(fp, fid_t):
    for f in listdir(fp):
        fid = f.split('.', 1)[0]
        if fid == fid_t:
            return fp + sep + f


def cut_info(target_fp, data_fp):
    """用于获取切带后文件数据..."""
    for i in get_data(data_fp):
        fn = search(target_fp, i[0])
        fn = os.path.normpath(fn)
        mid, miler_index, width, width_control = i
        yield mid, miler_index, width, width_control, fn
