#!/bin/bash
#!/bin/env bash
#PBS -N zh
#PBS -l nodes=1:ppn=28
#PBS -q batch
#PBS -V
cd "${PBS_O_WORKDIR}" || exit
run() {
  local NP
  local OPTIND
  local arg
  while getopts "p:v:" arg
  do
    NP=$(cat "$PBS_NODEFILE" | wc -l)
    cat "$PBS_NODEFILE" | sort | uniq | tee /tmp/nodes.$$ | wc -l
    cat "$PBS_NODEFILE" >/tmp/nodefile.$$
    case $arg in
      p)python "$OPTARG";;
      v)case $OPTARG in
          std)mpirun -genv I_MPI_DEVICE ssm -machinefile /tmp/nodefile.$$ -n "$NP" /home/share/software/vasp.5.4.1.05Feb16/intel/clean/vasp_std;;
          ncl)mpirun -genv I_MPI_DEVICE ssm -machinefile /tmp/nodefile.$$ -n "$NP" /home/share/software/vasp.5.4.1.05Feb16/intel/clean/vasp_ncl;;
          gam)mpirun -genv I_MPI_DEVICE ssm -machinefile /tmp/nodefile.$$ -n "$NP" /home/share/software/vasp.5.4.1.05Feb16/intel/clean/vasp_gam;;
          ?)echo "No such vasp executable!";;
        esac;;
      ?)echo "No such command!";;
    esac
  done
  rm -rf /tmp/nodefile.$$
  rm -rf /tmp/nodes.$$
}
run -p "$path"
