import sys
from datetime import datetime as __dt
from os import popen
from os.path import exists
import platform
from htsct.constants import QSUB


def qsub(nodes=1, cores=28, python_script=sys.argv[0]):
    """
    用于python脚本提交
    :param python_script: 本脚本执行路径
    :param nodes:所用节点数，default:1
    :param cores:每个节点所用核数,default:28
    """
    if platform.system() == 'Windows':
        return
    if not python_script:
        raise Exception("Please specify python script name!")
    if not exists("run"):
        with open(QSUB, "rb") as sh:
            lines = sh.readlines()
            for line in lines:
                line = line.decode("utf-8")
                if line.startswith("#PBS -l"):
                    line = line.encode("utf-8")
                    index = lines.index(line)
                    lines[index] = f"#PBS -l nodes={nodes}:ppn={cores}\n".encode("utf-8")
        with open(QSUB, "wb+") as sh:
            for line in lines:
                sh.write(line)
        with open("run", "a+") as f1:
            info = popen(f'qsub -v path="{python_script}" {QSUB}').read()
            print("任务ID：", info, end="")
            f1.write(info)
        exit()
    else:
        with open("run", "a+") as f1:
            f1.write(f"start running! {__dt.now()}")
